	; Example of a native function for DOS

	; Assemble with NASM:
	; NASM graphics.asm -o graphics.bin

	; Assembler directive to force 8086 instructions. This isn't required,
	; but I like to make my code 8086-compatible.
	cpu 8086

	; Switch to mode 13h (VGA 320*200 8-bit)
	mov ax, 0013h	; "Set video mode" function
	int 10h		; BIOS video service interrupt

	; Point ES:DI (destination for STOSW) to the start of the VGA
	; framebuffer
	mov ax, 0A000h
	mov es, ax
	xor di, di

	; For each row...
	mov dl, 200	; Counter of remaining rows
RowLoop:
	; For each color...
	xor ax, ax	; AX holds two pixels at a time
	mov dh, 16	; Counter of remaining colors
ColorLoop:
	; Set 20 pixels
	mov cx, 10
	rep stosw
	; Set next color
	add ax, 0101h
	; End of color loop
	dec dh
	jnz ColorLoop
	; End of row loop
	dec dl
	jnz RowLoop

	; Wait for a key to be pressed
	xor ah, ah	; "Wait for key" function
	int 16h		; BIOS keyboard service interrupt

	; Switch to text mode (where we probably came from)
	mov ax, 0003h
	int 10h

	; Return to NewtonScript. In this example, we did not use the stack,
	; so all we need is a RETF.
	retf